(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["fpDomAlert"] = factory();
	else
		root["fpDomAlert"] = factory();
})(self, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 402:
/***/ ((module) => {



var compose = function compose() {
  for (
    var _len = arguments.length, fns = Array(_len), _key = 0;
    _key < _len;
    _key++
  ) {
    fns[_key] = arguments[_key];
  }

  return function (x) {
    return fns.reduceRight(function (y, f) {
      return f(y);
    }, x);
  };
};

// GET ELEMENT

/**
 * Get DOM element given a param query
 * @param {string} prefix option to add a prefix ie. '#'
 * @param {string} param
 * @returns element
 */
var _getElement = function _getElement() {
  var prefix =
    arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return function (param) {
    var query = !prefix ? "" + param : "" + prefix + param;
    return document.querySelector(query);
  };
};

/**
 * Partial cyrring of @_getElement
 * prefix has been set up with # symbol
 * @param {string} param name of the id element
 */
var _getElementID = _getElement("#");

/**
 * Partial cyrring of @_getElement
 * prefix has been set up with . symbol
 * @param {string} param name of the class element
 */
var _getElementClass = _getElement(".");

// Create Element
var _createEl = function _createEl(type) {
  return document.createElement(type);
};

/**
 * Add attributes to a given element
 * @param {*} element
 * @param {attributes} opt. rest parameters of attributes under the form [name, value]
 * if null does not add attributes
 * @returns element
 */
var _setAttribute = function _setAttribute(element) {
  return function () {
    for (
      var _len2 = arguments.length, attributes = Array(_len2), _key2 = 0;
      _key2 < _len2;
      _key2++
    ) {
      attributes[_key2] = arguments[_key2];
    }

    !attributes[0]
      ? null
      : attributes.map(function (att) {
          return element.setAttribute(att[0], att[1]);
        });
    return element;
  };
};

/**
 * Create an element and set opt. attributes with @_setAttribute
 * @param {string} type of element ie div
 * @param {attributes} opt. rest parameters of attributes under the form [name, value]
 * if null does not add attributes
 * @return element
 */
var _createElement = compose(_setAttribute, _createEl);

/**
 * Create text node
 * @param {string} text
 * @returns
 */
var _createContent = function _createContent(text) {
  return document.createTextNode(text);
};

/**
 * AppendChild Element to a givent parent Element
 * @param {*} element
 * @returns element
 */
var _appendElement = function _appendElement(element) {
  return function () {
    for (
      var _len3 = arguments.length, children = Array(_len3), _key3 = 0;
      _key3 < _len3;
      _key3++
    ) {
      children[_key3] = arguments[_key3];
    }

    children.map(function (child) {
      return element.appendChild(child);
    });
    return element;
  };
};

var _PipeElementContent = function _PipeElementContent(
  createElement,
  createContent
) {
  return function (type) {
    return function () {
      for (
        var _len4 = arguments.length, attributes = Array(_len4), _key4 = 0;
        _key4 < _len4;
        _key4++
      ) {
        attributes[_key4] = arguments[_key4];
      }

      return function (text) {
        return _appendElement(createElement(type).apply(undefined, attributes))(
          createContent(text)
        );
      };
    };
  };
};

/**
 * Create a element types with a text node
 * @param {string} type element
 * @param {attributes} opt. rest parameters of attributes under the form [name, value]
 * if null does not add attributes
 * @param {string} text node
 */
var _createElementContent = _PipeElementContent(_createElement, _createContent);

/**
 * Change Display state
 * @param {string} state
 * @returns state
 */
var _switchDisplay = function _switchDisplay(state) {
  return state === "block" ? { state: "none" } : { state: "block" };
};

/**
 * Change the Display state of a given element
 * @param {*} element
 */
var _switchElementDisplay = function _switchElementDisplay(element) {
  return function () {
    element.style.display = _switchDisplay(element.style.display).state;
  };
};

module.exports = {
  _getElement: _getElement,
  _getElementID: _getElementID,
  _getElementClass: _getElementClass,
  _createElement: _createElement,
  _createElementContent: _createElementContent,
  _appendElement: _appendElement,
  _switchElementDisplay: _switchElementDisplay,
};


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var fp_dom_tool__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(402);
/* harmony import */ var fp_dom_tool__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(fp_dom_tool__WEBPACK_IMPORTED_MODULE_0__);
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }




var _alertContainer = function _alertContainer(alerTtype) {
  return fp_dom_tool__WEBPACK_IMPORTED_MODULE_0___default()._createElement("div")(["class", "_message__container _message--".concat(alerTtype)]);
};

var _alertMessage = fp_dom_tool__WEBPACK_IMPORTED_MODULE_0___default()._createElementContent("p")(["class", "_message__text"]);

var compose = function compose(alertContainer, alertMessage) {
  return function (alerTtype) {
    return function (content) {
      return fp_dom_tool__WEBPACK_IMPORTED_MODULE_0___default()._appendElement(alertContainer(alerTtype))(alertMessage(content));
    };
  };
};

var _alert = compose(_alertContainer, _alertMessage);

var _alertDanger = _alert("danger");

var _alertSuccess = _alert("success");

var _alertWarning = _alert("warning");

var _AlertCss = {
  padding: ".6rem",
  border: "2px solid #000",
  borderRadius: "0.3em",
  fontFamily: "'Montserrat', sans-serif",
  fontSize: "1.1rem",
  margin: "0.3rem 0",
  backgroundColor: "#fff",
  borderColor: "#000",
  color: "#000"
};

var _assignProperty = function _assignProperty(cloneAlert) {
  return function (newAlert) {
    return function (key) {
      var newProperty = _defineProperty({}, key, newAlert[key]);

      return _objectSpread(_objectSpread({}, cloneAlert), newProperty);
    };
  };
};

var _composeAlertStyle = function _composeAlertStyle(Alert) {
  return function (newAlert) {
    return Object.keys(newAlert).reduce(function (cloneAlert, key) {
      return Alert.hasOwnProperty(key) ? _assignProperty(cloneAlert)(newAlert)(key) : cloneAlert;
    }, _objectSpread({}, Alert));
  };
};

var _createAlertStyle = _composeAlertStyle(_AlertCss);

var _setStyle = function _setStyle(element) {
  return function (newAlertCss) {
    Object.assign(element.style, newAlertCss);
    return element;
  };
}; // const body = _tool._getElement()("body");
// const _messageContainer = _tool._createElement("div")(["class", "_message"]);
// const appendMessageContainer = _tool._appendElement(_messageContainer);
// appendMessageContainer(_alertSuccess("Yes"));
// _tool._appendElement(body)(_messageContainer);
// const _switchAlertDisplay = _tool._switchElementDisplay(_messageContainer);
// _switchAlertDisplay();


var _export = {
  _alert: _alert,
  _alertDanger: _alertDanger,
  _alertSuccess: _alertSuccess,
  _alertWarning: _alertWarning,
  _createAlertStyle: _createAlertStyle,
  _setStyle: _setStyle
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (_export);
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=fp-dom-alert.js.map